<?php
//    Copyright 2016 Andrii Salnikov
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//

//
// NOTE: APIv2 VOMS Admin User stats API introduced in the reference inplementation v2.7.0
// Implementation in PVA rely on the own VOMSREST API implementation
// There are no Suspended/Expired users tracking in PVA, so in practice only the users count is reported
//

    error_reporting(E_ALL); ini_set("display_errors", 1);
    ini_set("include_path", "./interfaces:./modules:./lang:./conf");

    // get API type and DN format
    require_once("operations.php");
    require("VOMSREST.php");

    // REST methods map
    $rest_map_file = "rest/apiv2.map";
    require($rest_map_file);

    // methods implementation
    class VOMSAPIv2 extends VOMSREST {
        public function user_stats() {
            // check permissions
            $this->acl_check(get_ACL_permissions(), "membership", "r" );
            // generate result
            $result = array (
                "expiredUsersCount" => 0,
                "suspendedUsersCount" => 0,
                "usersCount" => getVOMembersCount()
            );
            return $result;
        }

        public function suspended_users() {
            return array("suspendedUsers" => array());
        }

        public function expired_users() {
            return array("expiredUsers" => array());
        }

    }
    
    // replace dashes with underscores in method name
    if ( isset($_REQUEST['method']) ) {
        $_REQUEST['method'] = str_replace('-','_',$_REQUEST['method']);
    }

    // general handling engine
    $restapi = new VOMSAPIv2($methods_map);
    $result = $restapi->handle($_REQUEST);
    $restapi->setformat("json");
    echo $restapi->applyformat($result);
?>
